Description

follow up for #26561

this patch replaces all .force_encoding('ASCII-8BIT') or .force_encoding('BINARY') to .b

String#b is available since Ruby 2.0

https://www.rubydoc.info/stdlib/core/2.0.0/String%3ab

#b returns unfrozen string so + can be omited, this way the code can be much shorter and it's even faster

# frozen-string-literal: true

require 'benchmark/ips'

def test_b

  'looooonghsalfhfslakfsalhsfalhfsalhfsalhfsa'.b

end

def test_force

  (+"looooonghsalfhfslakfsalhsfalhfsalhfsalhfsa").force_encoding('ASCII-8BIT')

end

Benchmark.ips do |x|

  x.report('b', 'test_b')

  x.report('force', 'test_force')

end

 
Warming up --------------------------------------

                   b   278.357k i/100ms

               force   191.903k i/100ms

Calculating -------------------------------------

                   b      8.628M (± 6.3%) i/s -     43.145M in   5.023695s

               force      3.888M (± 7.9%) i/s -     19.382M in   5.021761s

Related issues:

Related to Redmine - Feature #26561: Enable frozen string literals Closed

Associated revisions

Revision 17992 - 2019-03-20 02:36 - Go MAEDA

Use #b shortcut instead of #force_encoding (#31059).

Patch by Pavel Rosický.

History

#1 - 2019-03-19 23:33 - Go MAEDA

I think you can remove #dup placed before #b because #b returns copied string.

The attached patch:

str = str.dup.b

 proposing change:
https://www.redmine.org/issues/26561
https://www.rubydoc.info/stdlib/core/2.0.0/String%3ab


str = str.b

#2 - 2019-03-19 23:48 - Pavel Rosický

- File core.patch added

- File tests.patch added

fixed, thanks

#3 - 2019-03-20 00:24 - Go MAEDA

- Target version set to 4.1.0

#4 - 2019-03-20 00:24 - Go MAEDA

- Related to Feature #26561: Enable frozen string literals added

#5 - 2019-03-20 02:37 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patches. Thank you for improving Redmine.

#6 - 2019-03-20 06:41 - Go MAEDA

- Subject changed from use #b shortcut instead of #force_encoding to Use #b shortcut instead of #force_encoding

Files

core.patch 6.54 KB 2019-03-19 Pavel Rosický

tests.patch 7.77 KB 2019-03-19 Pavel Rosický

core.patch 6.51 KB 2019-03-19 Pavel Rosický

tests.patch 7.77 KB 2019-03-19 Pavel Rosický
